// metaballs 1.1 (30.12.2012) tebe/madteam

unit blobs;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

  blob: array [0..15] of record
                          x,y, adx, ady, r: integer;
                         end;

  aborted: Boolean;


const

number_of_blobs = 8;
screen_width = 200;
screen_height = 200;


implementation

{$R *.dfm}


procedure blobs_main;
var i, x, y: integer;
    distance, density: integer;
    pixel_brightness: byte;
    fraction: real;
    bmp: TBitmap;
begin

bmp:=TBitmap.Create;
bmp.Width:=screen_width;
bmp.Height:=screen_height;

repeat

 Application.ProcessMessages;
 if Aborted then Break;

 for y := 0 to screen_height-1 do
  for x := 0 to screen_width-1 do begin

   pixel_brightness:=0;

   for i := 0 to number_of_blobs - 1 do begin

    distance := round(sqrt(sqr(blob[i].x-x) + sqr(blob[i].y-y)));   // to z pitagorasa c^2=a^2+b^2  odleglosc dwoch punktow

    if distance > blob[i].r then                 // odleglosc > srednicy oznacza brak bloba
     density:=0
    else begin
     fraction := sqr(distance/blob[i].r);      // tutaj mamy bloba, policzymy jego "gestosc"
     density := round(sqr(1-fraction)*256);
    end;

    pixel_brightness:=(pixel_brightness+density) mod 160;   // kolor, jego "przesterowanie" wplywa na ciekawy efekt koncowy

   end;

   bmp.Canvas.Pixels[x,y] := rgb(pixel_brightness, pixel_brightness, pixel_brightness);

  end;

  form1.Image1.Picture.Graphic:=bmp;


// zwiekszamy pozycje X:Y blobow na podstawie ADX:ADY

  for i := 0 to number_of_blobs-1 do begin

   if blob[i].x+blob[i].r>screen_width then begin blob[i].adx:=-blob[i].adx; blob[i].x:=screen_width-blob[i].r end;
   if blob[i].x-blob[i].r<0 then begin blob[i].adx:=-blob[i].adx; blob[i].x:=blob[i].r end;

   blob[i].x:=blob[i].x + blob[i].adx;

   if blob[i].y+blob[i].r>screen_height then begin blob[i].ady:=-blob[i].ady; blob[i].y:=screen_height-blob[i].r end;
   if blob[i].y-blob[i].r<0 then begin blob[i].ady:=-blob[i].ady; blob[i].y:=blob[i].r end;

   blob[i].y:=blob[i].y + blob[i].ady;

  end;

until false;

bmp.Free;

end;


procedure TForm1.Button1Click(Sender: TObject);
var i: integer;
begin

// losujemy pozycje poczatkowe X:Y blobow oraz ich przyrosty ADX:ADY

 randomize;

 for i := 0 to number_of_blobs-1 do begin
  blob[i].x:=random(screen_width);
  blob[i].y:=random(screen_height);
  blob[i].r:=random(48)+16;
  blob[i].adx:=random(3)+1;
  blob[i].ady:=random(3)+1;
 end;

// zaczynamy

 Aborted:=false;

 blobs_main;

end;


procedure TForm1.FormCreate(Sender: TObject);
begin
 doublebuffered:=true;
end;


procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if chr(Key)=#27 then Aborted:=true;
end;


end.
