// metaballs fast 1.6 (30.12.2012) tebe/madteam

unit blobs_fast;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Button1: TButton;
    chbSolidColor: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

  blobs: array [0..15] of record
                          x,y, adx, ady: integer;
                         end;

  tdensity: array [0..127, 0..127] of byte;

  aborted: Boolean;


const

radius = 4;
number_of_blobs = 8;
screen_width = 80;
screen_height = 60;


implementation

{$R *.dfm}


procedure blobs_main;
var i, x, y, c, u, v: integer;
    g, distance: real;
    density: byte;
    bmp: TBitmap;
begin

for y := 0 to screen_height-1 do
 for x := 0 to screen_width-1 do begin

    distance := sqrt ( sqr(x) + sqr(y) );

    if distance < radius then
     g:=1
    else
  	 g := radius / distance;

    tdensity[x, y]:=round(g*64);
   end;


bmp:=TBitmap.Create;
bmp.Width:=screen_width;
bmp.Height:=screen_height;


repeat

 sleep(100);

 Application.ProcessMessages;
 if Aborted then Break;

 for y := 0 to screen_height-1 do
  for x := 0 to screen_width-1 do begin

   density:=0;

   for i := 0 to number_of_blobs - 1 do begin

    u := abs(x - blobs[i].x);
    v := abs(y - blobs[i].y);

    density := density + tdensity[u, v];

   end;


   if form1.chbSolidColor.Checked then begin

    if density > 96 then
     c:=255
    else
     c:=0;

   end else begin

    if density in [80..96] then
  	 	c := 255
	  else
 	  	c := 0;

   end;


   bmp.Canvas.Pixels[x,y] := rgb(c, c, c);

  end;

  form1.Image1.Picture.Graphic:=bmp;


// zwiekszamy pozycje X:Y blobow na podstawie ADX:ADY

  for i := 0 to number_of_blobs-1 do begin

   if blobs[i].x+radius>screen_width then begin blobs[i].adx:=-blobs[i].adx; blobs[i].x:=screen_width-radius end;
   if blobs[i].x-radius<0 then begin blobs[i].adx:=-blobs[i].adx; blobs[i].x:=radius end;

   blobs[i].x:=blobs[i].x + blobs[i].adx;

   if blobs[i].y+radius>screen_height then begin blobs[i].ady:=-blobs[i].ady; blobs[i].y:=screen_height-radius end;
   if blobs[i].y-radius<0 then begin blobs[i].ady:=-blobs[i].ady; blobs[i].y:=radius end;

   blobs[i].y:=blobs[i].y + blobs[i].ady;

  end;

until false;

bmp.Free;

end;


procedure TForm1.Button1Click(Sender: TObject);
var i: integer;
begin

// losujemy pozycje poczatkowe X:Y blobow oraz ich przyrosty ADX:ADY

 randomize;

 for i := 0 to number_of_blobs-1 do begin
  blobs[i].x:=random(screen_width);
  blobs[i].y:=random(screen_height);
  blobs[i].adx:=random(3)+1;
  blobs[i].ady:=random(3)+1;
 end;

// zaczynamy

 Aborted:=false;

 blobs_main;

end;


procedure TForm1.FormCreate(Sender: TObject);
begin
 doublebuffered:=true;
end;


procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if chr(Key)=#27 then Aborted:=true;
end;


end.
